/*******************************************************************
*
*  DESCRIPTION: Atomic Model washcycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/
#ifndef __CLOTH_H
#define __CLOTH_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class cloth : public Atomic
{
public:
	cloth( const string &name = "cloth" ) ;	 // Default constructor
	virtual string className() const;
		
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Cin ;
	Port &Cout;
	Time preparationTime, time_zero;
	int Value;
	
};

// ** inline ** //
inline
string cloth::className() const
{
	return "cloth" ;
}

#endif   //__CLOTH_H


