/*******************************************************************
*
*  DESCRIPTION: Atomic Model washcycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/
#ifndef __DRYCYCLE_H
#define __DRYCYCLE_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class drycycle : public Atomic
{
public:
	drycycle( const string &name = "DryCycle" ) ;	 // Default constructor
	virtual string className() const;
		
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Din ;
	Port &Dout;
	Port &Ddone;
	Time preparationTime, time_zero;
	int Value;
	int busy;
};

// ** inline ** //
inline
string drycycle::className() const
{
	return "drycycle" ;
}

#endif   //__DRYCYCLE_H


