/*******************************************************************
*
*  DESCRIPTION: Atomic Model Queue
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

/** include files **/
#include "pcode.h"      // class Queue
#include "message.h"    // class ExternalMessage, InternalMessage
#include "mainsimu.h"   // MainSimulator::Instance().getParameter( ... )
#include "randlib.h"  
/** public functions **/

/*******************************************************************
* Function Name: Queue
* Description: 
********************************************************************/
pcode::pcode( const string &name )
: Atomic( name )
, in( addInputPort( "in" ) )
, wcontrol ( addInputPort( "wcontrol" ) )
, street( addOutputPort( "street" ) ) 
, qcontrol( addOutputPort( "qcontrol" ) )
, out( addOutputPort( "out" ) )
, preparationTime( 0, 0, 2, 0 )
, time_zero( 0, 0, 1, 0)
{
	string time( MainSimulator::Instance().getParameter( description(), "preparation" ) ) ;

	if( time != "" )
		preparationTime = time ;
}

/*******************************************************************
* Function Name: initFunction
* Description: Resetea la lista
* Precondition: El tiempo del proximo evento interno es Infinito
********************************************************************/
Model &pcode::initFunction()
{
	cout<<"THIS IS THE PINCODE\n"<<endl;
	//int base = 1000;
	//	for(int j=0;j<5;j++){
		codeList[0]= 1111;
		codeList[1]= 2222;
		codeList[2]= 3333;
		codeList[3]= 4444;
		codeList[4]= 5555;
		codeList[5]= 6666;
		codeList[6]= 7777;
		codeList[7]= 8888;
		codeList[8]= 9999;
		//base = base + (2*100) + (3*10) +(j*1);
		//codeList[j]= base;
	
	
	for(int i=9;i<99;i++){
		RAN =  ((double)rand()/(double)RAND_MAX ) * 10000;
		//cout<<RAN<<endl;
		codeList[i] = RAN;
	   
	}	
	
	cout<<"INITIAL FUNCTION FOR THR PINCODE\n"<<endl;
	moe = 0;
	RAN = 0;
	valid =0;
	busy = 1;
	return *this ;
}

/*******************************************************************
* Function Name: externalFunction
* Description: 
********************************************************************/
Model &pcode::externalFunction( const ExternalMessage &msg )
{
		int count=0;
		moe = msg.value();
		if(msg.port()== in ){
		//moe = msg.value();
		cout<<"WE ARE CHECKING THe PIN NUMBER\n"<<endl;
		
	for(int j=0;j<3;j++){	
		for(int i=0;i<99;i++){
			if(codeList[i]==moe){
				valid = 1;
				cout<<"THE NUMBER "<< moe <<" SENT IS VALID\n"<<endl;
				break;
							
			}
		//count++;
		}// if we found the number. we are here
		count++;
		if(valid==1){ //	extra
			cout<<"THE CODE IS CORRECT awooooooo\n"<<endl;
		break;
		}
		
		if(valid==0){	//extra
			cout<<"WRONG ENTRY< PLEASE RE_ENTER THE PINCODE\n"<<endl;
		//cout<<"THIS IS THE "<<count<<" time TRIAL ATTEMPTED\n"<<endl;	
		}
	
	cout<<"THIS IS THE "<<count<<" time TRIAL ATTEMPTED\n"<<endl;		
	//cout<<"WORNG CODE , BYE BYE CAR,OUT\n"<<endl;
	}
	
	
	}//IN port
		
		
		
		
		
		
		if(msg.port()== wcontrol ){
			cout<<"****THE VALUE IS IN THE PIN IS ****"<<moe<<"\n"<<endl;
			valid = 2;
		}
		if(!valid||valid==2){
			holdIn(active, time_zero);	
		} else{
			holdIn(active, preparationTime);
		}	
	return *this ;
}
/*******************************************************************
* Function Name: internalFunction
* Description: 
********************************************************************/
Model &pcode::internalFunction( const InternalMessage & )
{
	valid = 0;
	passivate();
	return *this ;
}

/*******************************************************************
* Function Name: outputFunction
* Description: 
********************************************************************/
Model &pcode::outputFunction( const InternalMessage &msg )
{
	 if(valid==0){
        cout<<"THE (in output fun) CODE SENT IS INVALID CODE"<< msg.time()<<"\n"<<endl;
 		sendOutput( msg.time(), street, moe);  
 		cout<<"BYE BYE CAR (MSG FROM PCODE)\n"<<endl;
 		sendOutput( msg.time(), qcontrol, 0 );
 	    cout   <<"WELCOME TO A NEW CAR TO THE QUEUE(MSG FROM PCODE OUTPUT\n"<<endl;
    }
    
    if(valid==1){
    	cout<< "THE VALUE IS VALID, SENDING IT TO WATER NEXT AT TIME"<< msg.time()<<"\n"<<endl;
    
    sendOutput( msg.time(), out, moe );
    cout<<"Now we checking the out  PORT OF THE PCODE\n"<<endl;
    }
    //cout<<"CHECKING THE BUSY SIGNAL IN PCODE\n"<<endl;

	if(valid==2){
		sendOutput( msg.time(), qcontrol, moe );
	cout<<"BUSY SIGNAL FROM PCODE --> QUEUE TO SEND THE NEXT CAR\n"<<endl;
	}
	return *this;
}
