/*******************************************************************
*
*  DESCRIPTION: Atomic Model Queue
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#ifndef __PCODE_H
#define __PCODE_H

//#include <list>
#include "atomic.h"     // class Atomic

class pcode : public Atomic
{
public:
	pcode( const string &name = "pcode" );					//Default constructor

	virtual string className() const ;
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &in;
	const Port &wcontrol;
	
			// an input port to change the value of busy
	Port &out;
	Port &street;
	Port &qcontrol;
	
	Time preparationTime;
	double codeList[100];
	//typedef list<Value> ElementList ;
	//ElementList elements ;
	int moe;
	int busy;
	int valid;
	int RAN;					// 1 = busy, 0 = not busy.
	Time time_zero;

};	// class Queue

// ** inline ** // 
inline
string pcode::className() const
{
	return "pcode" ;
}

#endif   //__PCODE_H
