/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "queue.h"      // class Queue
#include "MYQueue.h"      // class Queue
#include "generat.h"    // class Generator
#include "cpu.h"        // class CPU
#include "transduc.h"   // class Transducer
#include "trafico.h"    // class Trafico
#include "washcycle.h"
#include "rinsecycle.h"
#include "drycycle.h"
#include "shampoo.h"
#include "water.h"
#include "cloth.h"
#include "pcode.h"
void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Trafico>() , "Trafico" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<washcycle>() , "washcycle" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<rinsecycle>() , "rinsecycle" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<MYQueue>() , "MYQueue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<drycycle>() , "drycycle" ) ;
    SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<shampoo>() , "shampoo" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<water>() , "water" ) ;    
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<cloth>() , "cloth" ) ;    
    SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<pcode>() , "pcode" ) ;    
    
    
}