/*******************************************************************
*
*  DESCRIPTION: Atomic Model rinseCycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/

#include "rinsecycle.h"  // base header
#include "message.h"       // InternalMessage ....

#include "mainsimu.h"      // class MainSimulator


/*******************************************************************
* Function Name: washcycle
* Description: constructor
********************************************************************/
rinsecycle::rinsecycle( const string &name )
: Atomic( name )
, Rin( addInputPort( "Rin" ) )
, Rout( addOutputPort( "Rout" ) )
, preparationTime( 0, 0, 4, 0 )
, time_zero( 0, 0, 1, 0)
{
	string time( MainSimulator::Instance().getParameter( description(), "preparation" ) ) ;

	if( time != "" )
		preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
* Description: Resetea la Value
* Precondition: El tiempo del proximo event interno es Infinito
********************************************************************/
Model &rinsecycle::initFunction()
{
	Value = 0;
	return *this ;
}
/*******************************************************************
* Function Name: externalFunction

********************************************************************/
Model &rinsecycle::externalFunction( const ExternalMessage &msg )
{
  if ( this->state() == passive)
  {
	Value = msg.value();
	//if(Value == 3) {
		//holdIn(active,time_zero);
		//cout<<"NO WASHING: at time"<< msg.time() <<endl;
	//} else {
		cout<<" NOW RINSING: AT Time " << msg.time()<<"\n" <<endl;
	    holdIn(active,preparationTime);
		
   }

	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &rinsecycle::internalFunction( const InternalMessage & )
{
	passivate();
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &rinsecycle::outputFunction( const InternalMessage &msg )
{
   // if(Value==3)
        //cout<<"Nothing has been done at time"<< msg.time()<<endl;
    //if(Value==1||Value==2){
    cout<<"Value sent through Rinse IS: "<<Value<<"\n"<<endl;
    cout<< "Finished RINSING AT TIME: "<< msg.time()<<"\n"<<endl;
    sendOutput( msg.time(), Rout, Value );
    cout<<"CAR SENT FROM RINSE --> CLOTH\n"<<endl;
	return *this;
}



