/*******************************************************************
*
*  DESCRIPTION: Atomic Model washcycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/
#ifndef __RINSECYCLE_H
#define __RINSECYCLE_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class rinsecycle : public Atomic
{
public:
	rinsecycle( const string &name = "RinseCycle" ) ;	 // Default constructor
	virtual string className() const;
		
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Rin ;
	Port &Rout ;
	Time preparationTime, time_zero;
	int Value;
};

// ** inline ** //
inline
string rinsecycle::className() const
{
	return "rinsecycle" ;
}

#endif   //__RINSECYCLE_H


