/*******************************************************************
*
*  DESCRIPTION: Atomic Model washcycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/
#ifndef __SHAMPOO_H
#define __SHAMPOO_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class shampoo : public Atomic
{
public:
	shampoo( const string &name = "shampoo" ) ;	 // Default constructor
	virtual string className() const;
		
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Sin ;
	Port &Sout ;
	Time preparationTime, time_zero;
	int Value;
	
};

// ** inline ** //
inline
string shampoo::className() const
{
	return "shampoo" ;
}

#endif   //__shampoo_H


