/*******************************************************************
*
*  DESCRIPTION: Atomic Model washcycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/
#ifndef __WASHCYCLE_H
#define __WASHCYCLE_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class washcycle : public Atomic
{
public:
	washcycle( const string &name = "WashCycle" ) ;	 // Default constructor
	virtual string className() const;
		
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Washin ;
	Port &Washout ;
	Time preparationTime, time_zero;
	int Value;
	//int busyValue;
};

// ** inline ** //
inline
string washcycle::className() const
{
	return "washcycle" ;
}

#endif   //__WASHCYCLE_H


