/*******************************************************************
*
*  DESCRIPTION: Atomic Model waterCycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/

#include "water.h"  // base header
#include "message.h"       // InternalMessage ....

#include "mainsimu.h"      // class MainSimulator


/*******************************************************************
* Function Name: water
* Description: constructor
********************************************************************/
water::water( const string &name )
: Atomic( name )
, Win( addInputPort( "Win" ) )
, Wout( addOutputPort( "Wout" ) )
, busy( addOutputPort( "busy" ) )
, preparationTime( 0, 0, 1, 0 )
, time_zero( 0, 0, 1, 0)
{
	string time( MainSimulator::Instance().getParameter( description(), "preparation" ) ) ;

	if( time != "" )
		preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
* Description: Resetea la Value
* Precondition: El tiempo del proximo event interno es Infinito
********************************************************************/
Model &water::initFunction()
{
	Value = 0;
	busyValue = 1;
	return *this ;
}
/*******************************************************************
* Function Name: externalFunction

********************************************************************/
Model &water::externalFunction( const ExternalMessage &msg )
{
	cout<<"NOW WATERING\n"<<endl;
	Value = msg.value();
	if(Value<4000){
		Value = 1;
		cout<<"OPTION 1 is CHOSEN\n"<<endl;
	} if(Value >3999 && Value <7000){
			Value = 2;
			cout<<"OPTION 2 is chosen\n"<<endl;
	} if(Value >6999 && Value <10000){
				Value = 3; 
			cout<<"OPTION 3 is chosen\n"<<endl;
		}	
	
 	
 	if ( this->state() == passive){
		
		if(Value == 3) {
			holdIn(active,time_zero);
			cout<<"NO WATERING : at time "<< msg.time()<<"\n" <<endl;
		} else {
			holdIn(active,preparationTime);
			cout<<" NOW Watering: at Time: " << msg.time()<<"\n" <<endl;
		}
	}
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &water::internalFunction( const InternalMessage & )
{
	passivate();
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &water::outputFunction( const InternalMessage &msg )
{
    if(Value==3)
        cout<<"Nothing has been done at time"<< msg.time()<<endl;
    if((Value==1||Value==2) && (Value!=3))
    cout<< "FINISHED Watering at time "<< msg.time()<<"\n"<<endl;    
    cout<<"Value sent through WATER IS: "<<Value<<"\n"<<endl;
    sendOutput( msg.time(), Wout, Value );
	cout<<"This is to check the WOUT\n"<<endl;
	//sendOutput( msg.time(), busy, busyValue);
	//cout<<"THIS to chech BUSY SIGNAL"<<endl;
	return *this;
}