/*******************************************************************
*
*  DESCRIPTION: Atomic Model washcycle
*
*  AUTHOR: Ibrahim Hamdy, Akram Saleh, Mohamad Najm
*
*  DATE: 27/11/2004
*
*******************************************************************/
#ifndef __WATER_H
#define __WATER_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class water : public Atomic
{
public:
	water( const string &name = "Water" ) ;	 // Default constructor
	virtual string className() const;
		
protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &Win ;
	Port &Wout ;
	Port &busy ;
	Time preparationTime, time_zero;
	int Value;
	int busyValue;
};

// ** inline ** //
inline
string water::className() const
{
	return "water" ;
}

#endif   //__WATER_H


